//First Author: A.Vinci (mercurio@altrove.cjb.net)
//Second Author: Kornel Misiejuk (lenrock@2p.pl)
//Third Author: BatBat (fbat76@yahoo.fr)

 const NS_PROCESS_CONTRACTID    = "@mozilla.org/process/util;1"
 const NS_LOCAL_FILE_CONTRACTID = "@mozilla.org/file/local;1";
 const nsIFile            			= Components.interfaces.nsIFile;
 const nsILocalFile       			= Components.interfaces.nsILocalFile;
 const C                 			  = Components;
 
 const HTTRACK_PATH = getFFUserDir("\\extensions\\{3cd27e92-1a30-11da-94c6-00e08161165f}\\httrack\\") + "httrack.exe";
 const DIRSEPARATOR 	= "\\";
 const TOTAL_DECKS 		= 2;

//for locale string bundle -> access to spiderzilla.properties
function getString(stringName){
	return document.getElementById("spiderstrings").getString(stringName);
}

//Am I a loafer ?
function getValue(id) {
	return document.getElementById(id).value;
}
function getChecked(id) {
	return document.getElementById(id).checked;
}
function el(id) {
	return document.getElementById(id);
}

//This function change window's content. 
//I use "stack" since "deck" doesn't work on 0.9.9
function showDeck(Index) {
	for(var n=0; n<TOTAL_DECKS; n++)
		el("deck-"+n).collapsed=1;
	el("deck-"+Index).collapsed=0;
}

//Contestual help for Action menu
function setActionHelp() {
	var res= "actionhelp" + document.getElementById("MlActionList").value;
	document.getElementById("DActionHelp").value = getString(res);
}

// exit program
function exitProgram(){
   el("TbWebAddresses").statusText = el("TbWebAddresses").value;
   window.close()
}

// add new web address
function addWebaddress(stringURL) {
	// add nothing if URL is empty
	if (stringURL!="") {
  	var stringText = el("TbWebAddresses").value;
  	// last line feed gets lost sometimes
	  if (stringText!=""){
	    if (stringText.charAt(stringText.length-1)!='\n') {
  	    stringText += "\n";
  	    el("TbWebAddresses").value = stringText;
  	  }
	  }
		// search for same entry
		var re = new RegExp(stringURL+"\n","g");
		var searchResult = stringText.search(re);
	  // add if not existing
  	if (searchResult==-1) {
      el("TbWebAddresses").value += stringURL + "\n";
	  }
  }
}

//Init the program
function startProgram() {
	// load values from statusText. statusText values are stored into file
  el("TbProjectName").value = el("TbProjectName").statusText;
  el("TbWebAddresses").value = el("TbWebAddresses").statusText;
  if("arguments" in window && window.arguments.length > 0) {
    addWebaddress(window.arguments[0].url);
  }
	
	if(!el("TbBaseDir").statusText)
    el("TbBaseDir").statusText = getString("StandardDir");
	el("TbBaseDir").value = el("TbBaseDir").statusText;
	if(!el("TbProxySet").statusText)
    el("TbProxySet").statusText = getString("StandardProxy");
	el("TbProxySet").value = el("TbProxySet").statusText;
	if(!el("TbProxyPort").statusText)
    el("TbProxyPort").statusText = "80";
	el("TbProxyPort").value = el("TbProxyPort").statusText;
	el("TbMaxHTMLSize").value = el("TbMaxHTMLSize").statusText;
  el("TbMaxNonHTMLSize").value = el("TbMaxNonHTMLSize").statusText;
  el("TbMaxSiteSize").value = el("TbMaxSiteSize").statusText;
  el("TbMaxTime").value = el("TbMaxTime").statusText;
  el("TbMaxTransRate").value = el("TbMaxTransRate").statusText;
  el("TbMaxConBySec").value = el("TbMaxConBySec").statusText;
  el("TbMaxPause").value = el("TbMaxPause").statusText;
  el("TbRules").value = el("TbRules").statusText;
  el("TbNrMultiCon").value = el("TbNrMultiCon").statusText;
  el("TbTimeOut").value = el("TbTimeOut").statusText;
  el("TbMinTransRate").value = el("TbMinTransRate").statusText;
  
	for(var n = 1; n<=10;n++) {
		el("MlExternalDepth").appendItem ( n ,n); 
		el("MlDepth").appendItem ( n ,n);
		el("MlNrRetries").appendItem ( n ,n);
	}
	el("MlNrRetries").value = el("MlNrRetries").statusText;
  el("HostControl").value = el("HostControl").statusText;
  el("MlLongName").value = el("MlLongName").statusText;
  el("MlK").value = el("MlK").statusText;
	el("MlActionList").value = el("MlActionList").statusText;
	el("MlDepth").value = el("MlDepth").statusText;
	el("MlExternalDepth").value = el("MlExternalDepth").statusText;
	
  el("CbImages").checked = el("CbImages").statusText=="true";
  el("CbArchives").checked = el("CbArchives").statusText=="true";
  el("CbMedia").checked = el("CbMedia").statusText=="true";
  el("CbExParsing").checked = el("CbExParsing").statusText=="true";
  el("CbGetNear").checked = el("CbGetNear").statusText=="true";
  el("CbTestURL").checked = el("CbTestURL").statusText=="true";
  el("CbCookies").checked = el("CbCookies").statusText=="true";
  el("CbParsing").checked = el("CbParsing").statusText=="true";
  el("CbForceHTTP").checked = el("CbForceHTTP").statusText=="true";
  el("CbKeepAlive").checked = el("CbKeepAlive").statusText=="true";
  el("CbTolerReq").checked = el("CbTolerReq").statusText=="true";
  el("CbUpHacks").checked = el("CbUpHacks").statusText=="true";
  el("CbSameDir").checked = el("CbSameDir").statusText=="true";
  el("CbGoUp").checked = el("CbGoUp").statusText=="true";
  el("CbGoDown").checked = el("CbGoDown").statusText=="true";
  el("CbGoBoth").checked = el("CbGoBoth").statusText=="true";
  el("CbSameAddress").checked = el("CbSameAddress").statusText=="true";
  el("CbSamePrin").checked = el("CbSamePrin").statusText=="true";
  el("CbSameTLD").checked = el("CbSameTLD").statusText=="true";
  el("CbGoEvery").checked = el("CbGoEvery").statusText=="true";
  el("CbDebugHead").checked = el("CbDebugHead").statusText=="true";
  el("CbNoCache").checked = el("CbNoCache").statusText=="true";
	el("CbStoreAllCache").checked = el("CbStoreAllCache").statusText=="true";
	el("CbNotReDown").checked = el("CbNotReDown").statusText=="true";
	el("CbDisplay").checked = el("CbDisplay").statusText=="true";
	el("CbNoLog").checked = el("CbNoLog").statusText=="true";
	el("CbQuiet").checked = el("CbQuiet").statusText=="true";
	el("CbLogExtraInfo").checked = el("CbLogExtraInfo").statusText=="true";
	el("CbLogDebug").checked = el("CbLogDebug").statusText=="true";
	el("CbLogOnScreen").checked = el("CbLogOnScreen").statusText=="true";
	el("CbOneLogFile").checked = el("CbOneLogFile").statusText=="true";
	el("CbNoIndex").checked = el("CbNoIndex").statusText=="true";
	el("CbSearchIndex").checked = el("CbSearchIndex").statusText=="true";
	el("CbRepExt").checked = el("CbRepExt").statusText=="true";
	el("CbNotQueryString").checked = el("CbNotQueryString").statusText=="true";
	el("CbGenError").checked = el("CbGenError").statusText=="true";
	el("CbKeepDel").checked = el("CbKeepDel").statusText=="true";
	el("CbASIS").checked = el("CbASIS").statusText=="true";
	el("CbMozUA").checked = el("CbMozUA").statusText=="true";

	setActionHelp();
}

// store default values
function storeDefault() {
  // overwrite statusText values which are stored on disk when window is closed
  el("TbProjectName").statusText = el("TbProjectName").value;
  el("TbBaseDir").statusText = el("TbBaseDir").value;
  el("TbProxySet").statusText = el("TbProxySet").value;
  el("TbProxyPort").statusText = el("TbProxyPort").value;
  el("TbMaxHTMLSize").statusText = el("TbMaxHTMLSize").value;
  el("TbMaxNonHTMLSize").statusText = el("TbMaxNonHTMLSize").value;
  el("TbMaxSiteSize").statusText = el("TbMaxSiteSize").value;
  el("TbMaxTime").statusText = el("TbMaxTime").value;
  el("TbMaxTransRate").statusText = el("TbMaxTransRate").value;
  el("TbMaxConBySec").statusText = el("TbMaxConBySec").value;
  el("TbMaxPause").statusText = el("TbMaxPause").value;
  el("TbRules").statusText = el("TbRules").value;
  el("TbNrMultiCon").statusText = el("TbNrMultiCon").value;
  el("TbTimeOut").statusText = el("TbTimeOut").value;
  el("TbMinTransRate").statusText = el("TbMinTransRate").value;
  el("MlNrRetries").statusText = el("MlNrRetries").value;
  el("HostControl").statusText = el("HostControl").value;
  el("MlLongName").statusText = el("MlLongName").value;
  el("MlK").statusText = el("MlK").value;
  el("MlActionList").statusText = el("MlActionList").value;
  el("MlDepth").statusText = el("MlDepth").value;
  el("MlExternalDepth").statusText = el("MlExternalDepth").value;
 
  el("CbImages").statusText = el("CbImages").checked;
  el("CbArchives").statusText = el("CbArchives").checked;
  el("CbMedia").statusText = el("CbMedia").checked;
  el("CbExParsing").statusText = el("CbExParsing").checked;
  el("CbGetNear").statusText = el("CbGetNear").checked;
  el("CbTestURL").statusText = el("CbTestURL").checked;
  el("CbCookies").statusText = el("CbCookies").checked;
  el("CbParsing").statusText = el("CbParsing").checked;
  el("CbForceHTTP").statusText = el("CbForceHTTP").checked;
  el("CbKeepAlive").statusText = el("CbKeepAlive").checked;
  el("CbTolerReq").statusText = el("CbTolerReq").checked;
  el("CbUpHacks").statusText = el("CbUpHacks").checked;
  el("CbSameDir").statusText = el("CbSameDir").checked;
  el("CbGoUp").statusText = el("CbGoUp").checked;
  el("CbGoDown").statusText = el("CbGoDown").checked;
  el("CbGoBoth").statusText = el("CbGoBoth").checked;
  el("CbSameAddress").statusText = el("CbSameAddress").checked;
  el("CbSamePrin").statusText = el("CbSamePrin").checked;
  el("CbSameTLD").statusText = el("CbSameTLD").checked;
  el("CbGoEvery").statusText = el("CbGoEvery").checked;
  el("CbDebugHead").statusText = el("CbDebugHead").checked;
  el("CbNoCache").statusText = el("CbNoCache").checked;
	el("CbStoreAllCache").statusText = el("CbStoreAllCache").checked;
	el("CbNotReDown").statusText = el("CbNotReDown").checked;
	el("CbDisplay").statusText = el("CbDisplay").checked;
	el("CbNoLog").statusText = el("CbNoLog").checked;
	el("CbQuiet").statusText = el("CbQuiet").checked;
	el("CbLogExtraInfo").statusText = el("CbLogExtraInfo").checked;
	el("CbLogDebug").statusText = el("CbLogDebug").checked;
	el("CbLogOnScreen").statusText = el("CbLogOnScreen").checked;
	el("CbOneLogFile").statusText = el("CbOneLogFile").checked;
	el("CbNoIndex").statusText = el("CbNoIndex").checked;
	el("CbSearchIndex").statusText = el("CbSearchIndex").checked;
	el("CbRepExt").statusText = el("CbRepExt").checked;
	el("CbNotQueryString").statusText = el("CbNotQueryString").checked;
	el("CbGenError").statusText = el("CbGenError").checked;
	el("CbKeepDel").statusText = el("CbKeepDel").checked;
	el("CbASIS").statusText = el("CbASIS").checked;
	el("CbMozUA").statusText = el("CbMozUA").checked;
													
 
}

// Clear Webaddresses
function clearAddresses() {
  el("TbWebAddresses").value = "";
}

//Other
function selectBaseFolder() {
	const nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	var baseDirBundle=getString("baseDir");
	fp.init(window, baseDirBundle, nsIFilePicker.modeGetFolder);
	
	if (fp.show() == nsIFilePicker.returnOK) {
		var path = fp.file.path;
		document.getElementById("TbBaseDir").value = path;
	}
	el("TbBaseDir").statusText = el("TbBaseDir").value;
}

function executeFile(executable, args) {
  dump(getString("execFile")+" ("+args.length+")\n"+executable.path+" "+args.join(" ")+"\n");

  if (!executable.exists()) {
    alert(getString("execFile")+":\n"+getString("execFile2")+"\n'"+executable.path+"'");
    return false;
  }
  try {
    var process = Components.classes[NS_PROCESS_CONTRACTID].createInstance(Components.interfaces.nsIProcess);

    process.init(executable);

    var pid = new Object();
    process.run(false, args, args.length, pid);
  }
  catch (ex) {
    dump(getString("execFile3")+" '"+executable.path+"'\n");
    return false;
  }
  return true;
}

//function getChromeDir(subdir) {
//	var dir   = new C.Constructor("@mozilla.org/file/directory_service;1", "nsIProperties");
//    rv        = (new dir()).get("AChrom", C.interfaces.nsIFile).path;
//	return  rv + subdir;
//}

function getFFUserDir(subdir) {
	var dir   = new C.Constructor("@mozilla.org/file/directory_service;1", "nsIProperties");
  var rv    = (new dir()).get("ProfD", C.interfaces.nsIFile).path;
	return  rv + subdir;
}

//Builds command line 
function startDownload(){
	
	if (!getValue("TbProjectName")){
		alert(getString("projectName"));
		return;
	}
	if (!getValue("TbWebAddresses")){
		alert(getString("webUrl"));
		return;
	}
	if (!getValue("TbBaseDir")){
		alert(getString("baseDir"));
		return;
	}
	
	var stringText = getValue("TbWebAddresses");
	
	do {
		if (stringText!="") {
			var intPosLF=stringText.indexOf('\n');
			var stringFirstAddress;
			if (intPosLF==-1) {
				stringFirstAddress = stringText;
				stringText="";
			}
			else {
				stringFirstAddress = stringText.substring(0,intPosLF);
				stringText = stringText.substring(intPosLF+1,stringText.length);
			} 
			
			if (stringFirstAddress!="")
			{	
       	var param = new Array;
       	var i=0;
         
       	if (getValue("MlActionList").value) {
       		var mir=0;
       		var wizd=1;
       		var sep=2;
       		var mirlin=3;
       		var testlin=4;
       		var skel=5;
       		var conti=6;
       		var updat=7;
       	
       		if (getValue("MlActionList") == mir)
       			param[i++] = "--mirror";
       		if (getValue("MlActionList") == wizd)
       			param[i++] = "--mirror-wizard";
       		if (getValue("MlActionList") == sep)
       			param[i++] = "--get-files";
       		if (getValue("MlActionList") == mirlin)
       			param[i++] = "--mirrorlinks";
       		if (getValue("MlActionList") == testlin)
       			param[i++] = "--spider";
       		if (getValue("MlActionList") == skel)
       			param[i++] = "--skeleton";
       		if (getValue("MlActionList") == conti)
       			param[i++] = "--continue";
       		if (getValue("MlActionList") == updat)
       			param[i++] = "--update";
       	}
       
       	param[i++] = stringFirstAddress; 
       	param[i++] = "-O" ;
       	param[i++] = getValue("TbBaseDir") +DIRSEPARATOR + getValue("TbProjectName");
       	
       	if (getValue("TbProxySet")) {						//proxy ?
       		param[i++] = "-P" ;
       		param[i++] = getValue("TbProxySet") + ":" +getValue("TbProxyPort");
       	}
       
       	//Rules**********************************************************
       	 if (getValue("MlDepth"))
       		param[i++] = "-r" + getValue("MlDepth");
       	 if (getValue("MlExternalDepth"))
       		param[i++] = "-%e" + getValue("MlExternalDepth");
       	 if (getValue("TbMaxNonHTMLSize")) {
       		param[i++] = "-m" + getValue("TbMaxNonHTMLSize");
       		if (getValue("TbMaxHTMLSize"))
       			param[i-1] = param[i-1]+ "," + getValue("TbMaxHTMLSize");
       	 }
       	 if (getValue("TbMaxSiteSize"))
       		param[i++] = "-M" + getValue("TbMaxSiteSize");
       	 if (getValue("TbMaxTime"))
       		param[i++] = "-E" + getValue("TbMaxTime");
       	 if (getValue("TbMaxTransRate"))
       		param[i++] = "-A" + getValue("TbMaxTransRate");
       	 if (getValue("TbMaxConBySec"))
       		param[i++] = "-%c" + getValue("TbMaxConBySec");
       	 if (getValue("TbMaxPause"))
       		param[i++] = "-G" + getValue("TbMaxPause");
       	//Flow***********************************************************
       	 if (getValue("TbNrMultiCon"))
       		param[i++] = "-c" + getValue("TbNrMultiCon");
       	 if (getValue("TbTimeOut"))
       		param[i++] = "-T" + getValue("TbTimeOut");
       	 if (getValue("MlNrRetries"))
       		param[i++] = "-R" + getValue("MlNrRetries");
       	 if (getValue("TbMinTransRate"))
       		param[i++] = "-J" + getValue("TbMinTransRate");
       	 if (getValue("HostControl"))
       		param[i++] = "-H" + getValue("HostControl");
       	//Links Option***************************************************
       	 if (getChecked("CbExParsing"))
       		param[i++] = "-%P0" ;
       	 if (getChecked("CbGetNear"))
       		param[i++] = "-n" ;
       	 if (getChecked("CbTestURL"))
       		param[i++] = "-t" ;
       	//Spider Option**************************************************
       	 if (getChecked("CbCookies"))
       		param[i++] = "-b0" ;
       	 if (getChecked("CbParsing"))
       		param[i++] = "-j0" ;
       	 if (getChecked("CbForceHTTP"))
       		param[i++] = "-%h" ;
       	 if (getChecked("CbKeepAlive"))
       		param[i++] = "-%k" ;
       	 if (getChecked("CbTolerReq"))
       		param[i++] = "-%B" ;
       	 if (getChecked("CbUpHacks"))
       		param[i++] = "-%s" ;
       	//Expert Option**************************************************
       	 if (getChecked("CbSameDir"))
       		param[i++] = "-S" ;
       	 if (getChecked("CbGoUp"))
       		param[i++] = "-U" ;
       	 if (getChecked("CbGoDown"))
       		param[i++] = "-D" ;
       	 if (getChecked("CbGoBoth"))
       		param[i++] = "-B" ;
       	 if (getChecked("CbSameAddress"))
       		param[i++] = "-a" ;
       	 if (getChecked("CbSamePrin"))
       		param[i++] = "-d" ;
       	 if (getChecked("CbSameTLD"))
       		param[i++] = "-l" ;
       	 if (getChecked("CbGoEvery"))
       		param[i++] = "-e" ;
       	 if (getChecked("CbDebugHead"))
       		param[i++] = "-%H" ;
       
       	//LoG Index Cache************************************************
       	 if (getChecked("CbNoCache"))
       		param[i++] = "-C0" ;
       	 if (getChecked("CbStoreAllCache"))
       		param[i++] = "-k" ;
       	 if (getChecked("CbNotReDown"))
       		param[i++] = "-%n" ;
       	 if (getChecked("CbDisplay"))
       		param[i++] = "-%v" ;
       	 if (getChecked("CbNoLog"))
       		param[i++] = "-Q" ;
       	 if (getChecked("CbQuiet"))
       		param[i++] = "-q" ;
       	 if (getChecked("CbLogExtraInfo"))
       		param[i++] = "-z" ;
       	 if (getChecked("CbLogDebug"))
       		param[i++] = "-Z" ;
       	 if (getChecked("CbLogOnScreen"))
       		param[i++] = "-v" ;
       	 if (getChecked("CbOneLogFile"))
       		param[i++] = "-f2" ;
       	 if (getChecked("CbNoIndex"))
       		param[i++] = "-I0" ;
       	 if (getChecked("CbSearchIndex"))
       		param[i++] = "-%I" ;
       	
       	//Build Options**************************************************
        	 if(getValue("MlLongName"))
       		param[i++] = "-L" + getValue("MlLongName");
       	 if(getValue("MlK")) {
       		var kwart="1"
       		if(getValue("MlK") == kwart)
       			param[i++] = "-K" ;
       		if(getValue("MlK") != kwart)
       			param[i++] = "-K" + getValue("MlK");
       	 }
       	 if (getChecked("CbRepExt"))
       		param[i++] = "-x" ;
       	 if (getChecked("CbNotQueryString"))
       		param[i++] = "-%q0" ;
       	 if (getChecked("CbGenError"))
       		param[i++] = "-o0" ;
       	 if (getChecked("CbKeepDel"))
       		param[i++] = "-X0" ;
       	 if (getChecked("CbASIS"))
       		param[i++] = "-%p" ;
       	
       	//System********************************************************
       	 if (getChecked("CbMozUA")) {
       		param[i++] = "-F"  ;
       		param[i++] = navigator.userAgent ;
       	 }
       	 
       	//Filters********************************************************
       	 var stringbuff = ""; //Get filters
       	 if (getChecked("CbImages"))
       		stringbuff+="+*.gif +*.jpg +*.jpeg +*.gif +*.bmp +*.png";
       	 if (getChecked("CbArchives"))
       		stringbuff+="+*.zip +*.rar +*.tgz +*.gz +*.rar";
       	 if (getChecked("CbMedia"))
       		stringbuff+="+*.mov +*.mpg +*.mpeg +*.mp3 +*.avi +*.asf";
       	 stringbuff+=getValue("TbRules");
       	 var ss = stringbuff.split(" ");
       	 for (var n=0; n<ss.length; n++)
       		param[i++] = ss[n];
       
       	var httrack = Components.classes[NS_LOCAL_FILE_CONTRACTID].createInstance(nsILocalFile);
         httrack.initWithPath(HTTRACK_PATH);
       	executeFile(httrack,param);

      }
    }
  } while (stringText!="");
}

// loads a help page -- needs to be passed a case-variable 'whichPage'
function loadHelpPage(whichPage) {
	var pageUrl;
    
	switch(whichPage) {
		case "Homepage": 
			pageUrl = getString("spiderzilla.Homepage");
			break;
    case "SecondHomepage":
      pageUrl = getString("spiderzilla.SecondHomepage");
      break;
		case "httrackHomepage":
			pageUrl = getString("spiderzilla.httrackHomepage");
      break;
	}
	// --- --- --- // 
	var windowService = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var currentWindow = windowService.getMostRecentWindow("navigator:browser");
    if (currentWindow) {
		try {
		  currentWindow.delayedOpenTab(pageUrl);
		} catch(e) {currentWindow.loadURI(pageUrl); }
	}
	else
		window.open(pageUrl);
}

